<?php

 defined('WM3_cEXEC') or die('Denied');

 // Form example
 // This example create a page with a simple form and fields validation

 $pageID = $w3->getVariable('pageID'); // Take pageID variable from get or post
 
 // Create a wm3GUIForm object
 // parameters are: form action, form title and form name
 $form_action = 'index.php?section='.WM3_cSECTION_PAGES.'&pageID='.$pageID;
 $form = new wm3GUIForm($w3,$form_action,'Form title','form_name');
 $form->setSubmitLabel('Send data'); // Set submit button label

 // Create form textfields
 // Parameters are: field name, field value, field label, field size, field maxlenght
 //                 and a boolean (true for a password field, false for normal textfield)
 $name  = new wm3GUITextField('name', $w3->getVariable('name'), 'Name:');
 $age   = new wm3GUITextField('age',  $w3->getVariable('age'),  'Age:',10);
 $email = new wm3GUITextField('email',$w3->getVariable('email'),'Email:');
 
 // Create form select
 // Parameters are: field name, field value, field label, an array of wm3GUIOption objects
 $gender = new wm3GUISelect('gender',$w3->getVariable('gender'),'Gender:',array(new wm3GUIOption('Male','1'),new wm3GUIOption('Female','2')));

 // Create form checkbox
 // Parameters are: field name, field value, field label
 $check = new wm3GUICheckBox('check',$w3->getVariable('check'),'Checkme:');

 // Add validation for name field (can not be empty)
 // Parameters are: validation constant and error message
 $name->addValidation(WM3_cVALIDATE_NOT_NULL,'Error: Empty name');

 // Add validation for age field (must be >= 18)
 // Parameters are: validation constant, error message and an integer
 $age->addValidation(WM3_cVALIDATE_GREATER_EQUAL_THAN,'Error: Age must be greater or equal to 18',18);

 // Add validation for email field (must be an email)
 // Parameters are: validation constant and error message
 $email->addValidation(WM3_cVALIDATE_EMAIL,'Error: Invalid email');

 // Add the fields to the form
 $form->addField($name);
 $form->addField($age);
 $form->addField($gender);
 $form->addField($email);
 $form->addField($check);
 
 // Add also an hidden field
 $form->addField(new wm3GUIHiddenField('test','1'));

 // Execute form
 if($form->wasSubmit()) // The form was submit
  {
   if(!$form->validate()) echo $form->render(); // Form validation error (redraw the form)
   else
    {
	 // Form validation passed
     echo "Form fields submitted:<br>";
     echo "<br>Name: "   .$w3->getVariable('name');
     echo "<br>Age: "    .$w3->getVariable('age');
     echo "<br>Gender: " .$w3->getVariable('gender');
     echo "<br>Email: "  .$w3->getVariable('email');
     echo "<br>Checkme: ".$w3->getVariable('check');
     echo "<br>Test (hidden field): ".$w3->getVariable('test');
     echo "<br><br>You can now process sended data.";
    }
  }
 else
  {
   // Form default values
   $check->setValue(WM3_cENABLED);

   echo $form->render(); // Render the form (first time)
  }

?>
